﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public scanning As Boolean
	Private bc As ByteConverter
	Type Beacon (uniqueid As String, uuid As String, minor As Int, major As Int, distance As Double, TIME As Long)
	Public beacons As Map
	Public const TIME_TO_LIVE_SECONDS As Int = 30
	Private Timer1 As Timer
End Sub

Sub Service_Create
	manager.Initialize("manager")
	beacons.Initialize
	Timer1.Initialize("timer1", TIME_TO_LIVE_SECONDS * DateTime.TicksPerSecond)
	Timer1.Enabled = True
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Scan
	manager.Scan2(Null, True)
	scanning = True
End Sub


Public Sub StopScan
	manager.StopScan
	scanning = False
End Sub

Private Sub Timer1_Tick
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Dim key As Int = -1 'type is important. Must be Int.
	If AdvertisingData.ContainsKey(key) Then
		Dim b() As Byte = AdvertisingData.Get(key)
		If b.Length > 4 And b(0) = 0x4c And b(1) = 0 And b(2) = 0x02 And b(3) = 0x15 Then
			Dim beacon As Beacon
			beacon.Initialize
			Dim raf As RandomAccessFile
			raf.Initialize3(b, False)
			Dim hex As String = bc.HexFromBytes(b)
			beacon.uuid = hex.SubString2(8, 40) 'bytes 4 - 19
			beacon.uniqueid = hex.SubString2(8, 48) 'this also includes the major and minor parts
			beacon.major = raf.ReadShort(20)
			beacon.minor = raf.ReadShort(22)
			Dim tx As Byte = raf.ReadSignedByte(24)
			beacon.distance = CalculateDistance(tx, RSSI)
			beacon.time = DateTime.Now
			beacons.Put(beacon.uniqueid, beacon)
			CallSub(Main, "StateChanged")
		End If
	End If
End Sub
'based on this answer: http://stackoverflow.com/questions/20416218/understanding-ibeacon-distancing
Private Sub CalculateDistance(tx As Int, rssi As Double) As Double
	If rssi = 0 Then Return -1
	Dim ratio As Double = rssi / tx
	If ratio < 1 Then
		Return Power(ratio, 10)
	Else
		Return 0.89976 * Power(ratio, 7.7095) + 0.111
	End If
End Sub


'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
